#ifdef _USE_WXWIDGETS_
#ifndef __bbcreaMaracasVisuSurfaceRendering_h_INCLUDED__
#define __bbcreaMaracasVisuSurfaceRendering_h_INCLUDED__
#include "bbcreaMaracasVisu_EXPORT.h"
#include "bbtkWxBlackBox.h"
#include "vtkRenderWindowInteractor.h"

#include "vtkImageData.h"
#include "vtkProp3D.h"

//#include "marInterface.h"

namespace bbcreaMaracasVisu
{

class bbcreaMaracasVisu_EXPORT SurfaceRendering
 : 
   public bbtk::WxBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(SurfaceRendering,bbtk::WxBlackBox);
  //BBTK_DECLARE_INPUT(In,vtkImageData*);
  BBTK_DECLARE_INPUT(Renderer,vtkRenderer*);
  BBTK_DECLARE_INPUT(Interactor,vtkRenderWindowInteractor*);
  BBTK_DECLARE_INPUT(In0,vtkImageData*);  
  BBTK_DECLARE_INPUT(In1,vtkImageData*);
  BBTK_DECLARE_INPUT(In2,vtkImageData*);
  BBTK_DECLARE_INPUT(In3,vtkImageData*);
  BBTK_DECLARE_INPUT(In4,vtkImageData*);

  BBTK_DECLARE_OUTPUT(Out1,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Out2,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Out3,vtkImageData*);
  BBTK_DECLARE_OUTPUT(Out4,vtkImageData*);
  BBTK_PROCESS(Process);
  void Process();
  BBTK_CREATE_WIDGET(CreateWidget);
  void CreateWidget(wxWindow*);

private:
	//marInterface* mar;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(SurfaceRendering,bbtk::WxBlackBox);
BBTK_NAME("SurfaceRendering");
BBTK_AUTHOR("car-prie@uniandes.edu.co");
BBTK_DESCRIPTION("Black Box of the module SurfaceRendering");
BBTK_CATEGORY("actor");
//BBTK_INPUT(SurfaceRendering,In,"Renderer to show the different prop3D",vtkImageData*,"");
BBTK_INPUT(SurfaceRendering,Renderer,"Renderer to show the different prop3D",vtkRenderer*,"");
BBTK_INPUT(SurfaceRendering,Interactor,"Renderer to show the different prop3D",vtkRenderWindowInteractor*,"");
BBTK_INPUT(SurfaceRendering,In0,"Input image to the SurfaceRendering",vtkImageData*,"");
BBTK_INPUT(SurfaceRendering,In1,"Input image to the SurfaceRendering",vtkImageData*,"");
BBTK_INPUT(SurfaceRendering,In2,"Input image to the SurfaceRendering",vtkImageData*,"");
BBTK_INPUT(SurfaceRendering,In3,"Input image to the SurfaceRendering",vtkImageData*,"");
BBTK_INPUT(SurfaceRendering,In4,"Input image to the SurfaceRendering",vtkImageData*,"");
BBTK_OUTPUT(SurfaceRendering,Out1,"Output resulting image",vtkImageData*,"");
BBTK_OUTPUT(SurfaceRendering,Out2,"Output resulting image",vtkImageData*,"");
BBTK_OUTPUT(SurfaceRendering,Out3,"Output resulting image",vtkImageData*,"");
BBTK_OUTPUT(SurfaceRendering,Out4,"Output resulting image",vtkImageData*,"");
BBTK_END_DESCRIBE_BLACK_BOX(SurfaceRendering);
}
// EO namespace bbcreaMaracasVisu

#endif // __bbcreaMaracasVisuSurfaceRendering_h_INCLUDED__
#endif // _USE_WXWIDGETS_

