
#include "CutModelFigureCylinder.h"

CutModelFigureCylinder::CutModelFigureCylinder()
{
	_vtkcylinder	= vtkCylinderSource::New();
	_vtkcylinder->SetResolution(20);
}
//----------------------------------------------------------------------------
CutModelFigureCylinder::~CutModelFigureCylinder()  // virtual
{
	_vtkcylinder->Delete();
}
//----------------------------------------------------------------------------
bool CutModelFigureCylinder::IfPointInside(double x, double y, double z) // virtual
{
	double in[4],out[4];
	in[0]=x;
	in[1]=y;
	in[2]=z;
	in[3]=1;
	_inversModel->MultiplyPoint (in, out);

	bool result=false;
	if ((sqrt( out[0]*out[0] + out[2]*out[2] )<0.5 )  && (out[1]>-0.5) && (out[1]<0.5)  )
	{
		result=true;
	}
	return result;
}
//----------------------------------------------------------------------------
double CutModelFigureCylinder::GetTheoricVolume() // virtual
{
	double piTMP=3.14159265;
	return piTMP*(_sx/2)*(_sz/2)*_sy;
}
//----------------------------------------------------------------------------
const char *CutModelFigureCylinder::GetName() // virtual
{
	return "Cylinder";
}
vtkPolyData* CutModelFigureCylinder::getPolyData(){
	return _vtkcylinder->GetOutput();
}
//----------------------------------------------------------------------------
