/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: CutModelSaveBinInfo.h,v $
  Language:  C++
  Date:      $Date: 2009/09/08 08:14:27 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/




#ifndef __CutModelSaveBinInfoH__
#define __CutModelSaveBinInfoH__

#include <iostream>
#include <vector>
#include "CutModelException.h"

#include <vtkPolyData.h>
#include <vtkPolyDataWriter.h>
#include <vtkPolyDataReader.h>
#include <vtkPolyDataMapper.h>
#include <vtkTransform.h>
#include <vtkMatrix4x4.h>
#include <vtkActor.h>

enum UNDOTYPE
{
    CUTMODEL_ADD = 0,	
	CUTMODEL_REMOVE = 10,
	CUTMODEL_CUT= 20,
	
};

class CutModelSaveBinInfo  {

public:
	
	CutModelSaveBinInfo(int id, int currentaction,UNDOTYPE actiontype, std::string path);
	~CutModelSaveBinInfo();

	int getId(){
		return _id;
	}	

	UNDOTYPE getActionType(){
		return _actiontype;
	}
	std::string getSTDFileName()throw( CutModelException){
		if(_stdFilename==""){
			throw new CutModelException("Filename undoredo does not exists");
		}
		return _stdFilename;
	}

	/*void setSTDFileName(std::string filename){
		_stdFilename = filename;
	}*/

	int getCurrentShape(){
		return _currentshape;
	}

	void setCurrentShape(int currentshape){
		_currentshape=currentshape;
	}

	void savePolyData(vtkPolyData* polydata);

	vtkTransform* getPolyDataTransform()throw( CutModelException);	

	void saveMatrix4x4(vtkMatrix4x4* matrix);
	vtkTransform* getTransformFromMatrixFile()throw( CutModelException);

	void setRange(double* range){
		_range = range;
	}
	void setIsInside(bool isinside){
		_isinside = isinside;
	}

	double* getRange(){
		return _range;
	}
	bool getIsInside(){
		return _isinside;
	}
	
private:		
	
	int _id;
	UNDOTYPE _actiontype;
	int _currentshape;
	double* _range;
	bool _isinside;
	std::string _stdFilename;		
	std::string _matrixFilename;	
};



#endif 
