
#ifndef __ContourVOIWidget_h_INCLUDED_H__
#define __ContourVOIWidget_h_INCLUDED_H__


#include "manualContourModelRoi.h"
#include "manualRoiControler.h"
#include "manualViewRoi.h"
#include "wxVtkBaseView.h"
#include "wxVtk2DBaseView.h"
#include "mBarRange.h"
#include "marTypes.h"
  
#include "vtkImageMapToColors.h"
#include "vtkImageActor.h"




  class ContourVOIWidget;
  //------------------------------------------------------------------------------------------------------------------------------------
  // Event handling auxiliar class
  //------------------------------------------------------------------------------------------------------------------------------------
  class wxWidgetSliderMinMaxVOI : wxEvtHandler
  {
  public:
	  //--------------------------------------------------------------------------------------------------------------------------------
	  // Constructors ans destructors
	  //--------------------------------------------------------------------------------------------------------------------------------
		wxWidgetSliderMinMaxVOI(ContourVOIWidget *contourtool,mBarRange * modelBarRange);
		~wxWidgetSliderMinMaxVOI();		

	  //--------------------------------------------------------------------------------------------------------------------------------
	  // Min-Max Barrange received events
	  //--------------------------------------------------------------------------------------------------------------------------------
		void onBarrange(wxCommandEvent& event);
		void onActualChange_Bar(wxCommandEvent& event);
		void onStartChange_Bar(wxCommandEvent& event);
		void onEndChange_Bar(wxCommandEvent& event);
		void onSelectionEnd(wxCommandEvent& event);
		void onMovedBar(wxCommandEvent& event);

  private:
	  //--------------------------------------------------------------------------------------------------------------------------------
	  // Attributes
	  //--------------------------------------------------------------------------------------------------------------------------------
	  ContourVOIWidget	*mcontourtool;
	  mBarRange			*modBarRange;
  };


//--------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------------

  class creaMaracasVisu_EXPORT ContourVOIWidget : public wxPanel
  {
  public:
	ContourVOIWidget( wxWindow *parent, wxVtkBaseView *wxvtkbaseview , vtkImageData* imagedata);
    ~ContourVOIWidget();
    void ConfigureVTK();

	wxVtkBaseView *GetWxVtkBaseView();
	void GetVOI( int voi[6] );


  private:
	mBarRange				*mbarrange;

	vtkImageData			*imagedata;
	wxVtkBaseView			*wxvtkbaseview;

	manualRoiControler		*_manRoiControl;
	manualContourModel		*_mContourModel;
	manualViewRoi			*_mViewRoi;

  };

#endif  // __ContourVOIWidget_h_INCLUDED_H__

