/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasImageBrowser02.h,v $
  Language:  C++
  Date:      $Date: 2009/05/19 11:17:26 $
  Version:   $Revision: 1.2 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __WX__IMAGE__BROWSER02__
#define __WX__IMAGE__BROWSER02__

#include "wx/wxprec.h"
#ifdef __BORLANDC__
#  pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif



#include <wx/window.h>
#include <wx/imaglist.h>
#include <wx/panel.h>
#include <wx/listctrl.h>
#include <wx/splitter.h>

#include "marParameters.h" 
#include "widgets/wxVtkBaseView.h" 
//#include "widgets/wxImageViewerWidget.h"
#include "widgets/wxReadingPriorityPanel.h"

#include "manualContourModelRoi.h"
#include "manualRoiControler.h"
#include "manualViewRoi.h"


BEGIN_DECLARE_EVENT_TYPES()
 DECLARE_EVENT_TYPE(wxEVT_MARACASIMAGEBROWSERCUTIMAGE, -1)
END_DECLARE_EVENT_TYPES()


/**
 * \brief Panel class that show thumbnails images
 */
class wxMaracasImageBrowser02 : public wxPanel
{
public:
    wxMaracasImageBrowser02( wxWindow* parent, marFilesBase *dicom ,marParameters* parameters );
    //wxMaracasImageBrowser02( wxWindow* parent, marInterface* mar, wxWindowID id = -1 );
    ~wxMaracasImageBrowser02();

    void LoadData( marImageData *marimagedata);
    void GetROI( int ext[6] );
    void SetROI( int voi[6] );
	bool GetRoiSelected();
	

	void Start();
	void ForceToFinisReadActiveImages();

	void Refresh();
	void OnRefreshView(wxCommandEvent & event);
	void OnRefreshView2(wxCommandEvent & event);
	void OnBtnResetRoi( wxCommandEvent &  event );
	void OnBtSaveVOIData(wxCommandEvent& event);
	void OnBtnCutVolume( wxCommandEvent &  event );

private:

	wxButton 			*_btnRestRoi;

	marParameters			*_parameters;
	LoadRangeImage			*_loadRangeImage;

	vtkBaseData				*_vtkbasedata_1;
	wxVtk2DBaseView			*_imageviewer2D_1;

	manualRoiControler		*_manRoiControl;
	manualContourModel		*_mContourModel;

	manualViewRoi			*_mViewRoi;



	DECLARE_EVENT_TABLE( );
};

#endif // __WX__IMAGE__BROWSER02__
