/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasParametersDialog.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:54 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __WX__GENERAL__PARAMETERS__DIALOG__
#define __WX__GENERAL__PARAMETERS__DIALOG__

#include <wx/wx.h>
#include <wx/dialog.h>
#include <wx/colordlg.h>
#include <wx/dirdlg.h>

#include <kernel/marInterface.h>
//XRC generated file:
#include "widgets/wxParametersDialog.h"

/**
 *  \brief Dialog class to select parameters
 */
class wxMaracasParametersDialog : public wxParametersDialog
{
public:

    wxMaracasParametersDialog( wxWindow* parent, marInterface* mar );

    void Reset( );
    bool Apply( );

    void OnOk( wxCommandEvent& event );
    void OnCancel( wxCommandEvent& event );
	void OnDefault( wxCommandEvent& event );
    void OnReset( wxCommandEvent& event );
    void OnApply( wxCommandEvent& event );


// PS ->     void OnBrowseWorkDir( wxCommandEvent& event );
// PS ->     void OnBrowseDICOMDir( wxCommandEvent& event );

// PS ->     void OnChoose3DColor( wxCommandEvent& event );
// PS ->     void OnChooseAxisColor( wxCommandEvent& event );

private:
    DECLARE_EVENT_TABLE( );
    marInterface*	_mar;
	wxString		_bak_edtThresholdIsoContours_String;
 	wxString		_bak_edtFlexionCoef_String;
	wxString		_bak_edtTensionCoef_String;
	wxString		_bak_edtMaskSize_String;
	wxString		_bak_edtDiscreetStep_String;
	wxWindow*		_parent;

	void SetBakEdit();

};

#endif // __WX__GENERAL__PARAMETERS__DIALOG__
