

#ifndef POINT_VIEW_H
#define POINT_VIEW_H


#include "vtkProperty.h"
#include "vtkActor.h"
#include "vtkSphereSource.h"
#include "vtkPolyDataMapper.h"
#include "wxVtkBaseView.h"
#include <vector>

class PointView  
{
public:
	PointView();
	~PointView();

	void	DeletePoints();
	void	SetWxVtkBaseView(wxVtkBaseView *wxvtkbaseview);
	void	Refresh();
	void	CreateNewPoint(double x, double y, int type);

	enum PointTypes
	{
		BLUE = 0,           
		MAGENTA,              
		GREEN,       
		YELLOW          
	};

private:
	wxVtkBaseView					*_wxvtkbaseview;
	
	std::vector<vtkPolyDataMapper*> point_mapped;
	std::vector<vtkActor*>			point_actor;
	//vtkActor						*_contourVtkActor;
	//vtkPolyDataMapper				*_bboxMapper;

	void			DeleteVtkObjects();

};

#endif // PointView


