/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: vtkImagePolyDataSeedConnectivity.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:54:57 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
// .NAME vtkImagePolyDataSeedConnectivity - create 
// .SECTION Description
//

#ifndef __vtkImagePolyDataSeedConnectivity_h
#define __vtkImagePolyDataSeedConnectivity_h

#include <vtkStructuredPointsToPolyDataFilter.h>

class vtkPolyData;

class vtkImagePolyDataSeedConnectivity : public vtkStructuredPointsToPolyDataFilter
{
public:
  static vtkImagePolyDataSeedConnectivity *New();
  vtkTypeRevisionMacro(vtkImagePolyDataSeedConnectivity,vtkStructuredPointsToPolyDataFilter);
  void PrintSelf(ostream& os, vtkIndent indent);

  // Description:
  // Set axis
  virtual void SetAxis(vtkPolyData*);
  vtkGetObjectMacro(Axis,vtkPolyData);

  // Description:
  // Set threshold ratio, by default .45
  vtkSetMacro(ThresholdRatio,double);
  vtkGetMacro(ThresholdRatio,double);

  // Description:
  // Get outer mold
  vtkGetObjectMacro(OuterMold,vtkPolyData);

protected:
  vtkImagePolyDataSeedConnectivity();
  ~vtkImagePolyDataSeedConnectivity();

  void Execute();
  void ClipImageWithAxis();

  double ThresholdRatio;

  vtkPolyData *Axis;
  //image data that has been clip with polydata
  vtkImageData *ClipImageData;
  vtkPolyData *OuterMold;
private:
  vtkImagePolyDataSeedConnectivity(const vtkImagePolyDataSeedConnectivity&);  // Not implemented.
  void operator=(const vtkImagePolyDataSeedConnectivity&);  // Not implemented.
};

#endif


