#include "manualRotationToolControler.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// _state = 0  // ..nothing..
// _state = 5  // move point
// _state = 6  // move all
// _state = 7  // Empty mouse drag

manualRotationToolControler::manualRotationToolControler()
{

}

// ----------------------------------------------------------------------------
manualRotationToolControler::~manualRotationToolControler()
{

}

// ----------------------------------------------------------------------------
manualRotationToolControler * manualRotationToolControler :: Clone()  // virtual
{
	manualRotationToolControler * clone = new manualRotationToolControler();
	CopyAttributesTo(clone);
	return clone;
}

// ---------------------------------------------------------------------------
void manualRotationToolControler::CopyAttributesTo( manualRotationToolControler * cloneObject)
{
	// Fathers object
	manualContourBaseControler::CopyAttributesTo(cloneObject);
}

// ----------------------------------------------------------------------------
void manualRotationToolControler::Configure() //virtual
{

}

// ----------------------------------------------------------------------------
void manualRotationToolControler::MouseClickLeft(int x, int y)
{
	int z = GetZ();
	
	if( IsEditable() )
	{	// move control point
  	  if ( (GetState()==0) && (GetManualViewBaseContour()->GetIdPoint(x,y,z)!=-1 ) ){
  		  bakIdPoint = GetManualViewBaseContour()->GetIdPoint(x,y,z);
		  SetState(5);
	  }
	}// IsEditable
	
	// move contour
	if ((GetState()==0) && (GetManualViewBaseContour()->GetPosibleSelected()==true))	{
		GetManualViewBaseContour()->InitMove(x,y,z);
		SetState(6);
	}
	
	// firstime create 3 control points and move one control point
	int size=GetManualViewBaseContour()->GetNumberOfPoints();
	if (GetState()==0) {
		if (size==0){
			AddPoint(x,y,z);
			AddPoint(x,y,z);
			bakIdPoint = GetManualViewBaseContour()->GetIdPoint(x,y,z);
			AddPoint(x,y,z);
			SetState(1);
		}
	}	
	
	GetManualViewBaseContour()->Refresh();
}

// ----------------------------------------------------------------------------
void manualRotationToolControler::MouseMove(int x, int y) // virtual
{
	int z=GetZ();

	GetManualViewBaseContour()->SelectPosibleContour(x,y,z);
	GetManualViewBaseContour()->SelectPosiblePoint(x,y,z);

	if (GetState()==1){	SetPoint( bakIdPoint , x , y ,z); }
	if (GetState()==5){	SetPoint( bakIdPoint , x , y ,z); }
	
	if (GetState()==6){
		GetManualViewBaseContour()->MoveContour(x,y,z);
	}
	GetManualViewBaseContour()->Refresh();
}

// ----------------------------------------------------------------------------
void manualRotationToolControler::DeleteActualMousePoint(int x, int y)  // virtual
{
}

// ----------------------------------------------------------------------------
void manualRotationToolControler::InitRoi(int ww, int hh, double porcentage)
{
	int zz;
	manualPoint *mp;

	if (GetManualContourModel()->GetSizeLstPoints() ==0)
	{
		zz = GetZ();
		AddPoint(0,0,zz);
		AddPoint(0,0,zz);
		AddPoint(0,0,zz);
	}

	double pp1=porcentage;
	double pp2=1-porcentage;

	mp = GetManualContourModel()->GetManualPoint(2);
	zz=(int)mp->GetZ();
	mp->SetPoint(ww*pp1,hh*pp1,zz);

	mp = GetManualContourModel()->GetManualPoint(1);
	zz=(int)mp->GetZ();
	cout <<  ww*pp2 <<hh*pp1 << zz<<endl;
	mp->SetPoint(ww*pp2,hh*pp1,zz);

	mp = GetManualContourModel()->GetManualPoint(0);
	zz=(int)mp->GetZ();
	cout <<  ww*pp2 <<hh*pp2 << zz<<endl;
	mp->SetPoint(ww*pp2,hh*pp2,zz);

	GetManualViewBaseContour() ->UpdateViewPoint(0);
	GetManualViewBaseContour() ->UpdateViewPoint(1);
	GetManualViewBaseContour() ->UpdateViewPoint(2);

	SetState(0);
	GetManualViewBaseContour()->Refresh();
}
