
#ifndef __HistogramDialogComboBoxItem__
#define __HistogramDialogComboBoxItem__


// ----------------------------------------------------------------------------
// wx headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// ----------------------------------------------------------------------------

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include <wx/wx.h>
#include <vector>

class HistogramDialogComboBoxItem
{
public:
	/*
	 Constructor
	*/
	HistogramDialogComboBoxItem();
	HistogramDialogComboBoxItem(int bar_width,int bar_height);
	~HistogramDialogComboBoxItem();

	void SetColors(std::vector<double> greyvect, std::vector<double> redvect, std::vector<double> greenvect, std::vector<double> bluevect);
	void SetTransferFunction(std::vector<double> greyvect, std::vector<double> value);
	wxBitmap GetBitmap();

	std::vector<double> getGreyVector(){return _greyvect;}
	std::vector<double> getRedVector(){return _redvect;}
	std::vector<double> getGreenVector(){return _greenvect;}
	std::vector<double> getBlueVector(){return _bluevect;}

	std::vector<double> getGreyVectorTransfer(){return _greyvecttransfunct;}
	std::vector<double> getValueVector(){return _value;}
private:
	

	std::vector<double> _greyvect;
	std::vector<double> _redvect;
	std::vector<double> _greenvect;
	std::vector<double> _bluevect;

	std::vector<double> _greyvecttransfunct;
	std::vector<double> _value;

	/*
	* Represents the color of the backGround. Default color is the parent color. 
	*/
	wxColour	colourParent;

	int _bar_width;
	int _bar_height;

	wxBitmap* colorBar_Bitmap;
	
};

#endif



