
/*=========================================================================

  Program:   wido
  Module:    $RCSfile: MaximumsDialog.h,v $
  Language:  C++
  Date:      $Date: 2008/10/31 16:32:47 $
  Version:   $Revision: 1.1 $
  Author: Monica Lozano

  Copyright (c) CREATIS (Centre de Recherche et d'Applications en Traitement de
  l'Image). All rights reserved. See Doc/License.txt or
  http://www.creatis.insa-lyon.fr/Public/wido/License.html for details.

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notices for more information.

Description:
Is a Dialog that sets two numbers: 
1)a x-value: maximum number that can take the x-axis
2)a y-value: maximum number that can take the y-axis
=========================================================================*/


#ifndef __MAXIMUMSDIALOG__
#define __MAXIMUMSDIALOG__


// ----------------------------------------------------------------------------
// wx headers inclusion.
// For compilers that support precompilation, includes <wx/wx.h>.
// ----------------------------------------------------------------------------
#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

class MaximumsDialog:public wxDialog
{
public:
	/*
	 Constructor
	*/
	MaximumsDialog(wxWindow *parent,wxString title);
	/*
	 Destructor
	*/
	//~MaximumsDialog();
	/*
	 Returns the X value wrote by the user
	*/
	float getXValue();
	/*
	 Returns the X value wrote by the user
	*/
	float getYValue();

private:
	/*
		TextControl for the x-maxvalue
	*/
	wxTextCtrl      *m_maxX;
	/*
		TextControl for the y-maxvalue
	*/
	wxTextCtrl      *m_maxY;
	/*
	 used to show the names of the text controls
	*/
	wxStaticText    *maxX;
	wxStaticText	*maxY;

	/*
	 ok Button
	*/
	wxButton		*okBtn;
	/*
	 cancel Button
	*/
	wxButton		*cancelBtn;


	DECLARE_CLASS(MaximumsDialog);
	// any class wishing to process wxWindows events must use this macro
	//DECLARE_EVENT_TABLE()
};

#endif


