

#include "vtkInteractorStyleBaseView2D.h"
#include <vtkObjectFactory.h>

vtkStandardNewMacro(vtkInteractorStyleBaseView2D);

//---------------------------------------------------------------------------
vtkInteractorStyleBaseView2D::vtkInteractorStyleBaseView2D()
{
	////////////
	// RaC 04-2010 This mechanism of adding new functionalities has to be made externally in order 
	// to maintain a plugin architecture. 
	// Remember: The manualInteractorWindowLevel changes the window level over the image
	//           The vtkInteractorScrollZ changes the slice with right click interaction
	//			 This vtkInteractorStyleBaseView2D gives the minimal interaction with a 2D scene
	//
	// _manualinteractorwindowlevel= new manualInteractorWindowLevel();
	// AddInteractorStyleMaracas( _manualinteractorwindowlevel );
	//
	// _vtkInteractorScrollZ = new vtkInteractorScrollZ();
	// AddInteractorStyleMaracas(_vtkInteractorScrollZ);
	////////////
}
//---------------------------------------------------------------------------
vtkInteractorStyleBaseView2D::~vtkInteractorStyleBaseView2D()
{
}

//---------------------------------------------------------------------------
void  vtkInteractorStyleBaseView2D::SetInteractorScrollZ(vtkInteractorScrollZ* interactorScroll)
{    
	_vtkInteractorScrollZ = interactorScroll;
	AddInteractorStyleMaracas(_vtkInteractorScrollZ);
}

//---------------------------------------------------------------------------
void  vtkInteractorStyleBaseView2D::SetInteractorWindowLevel(manualInteractorWindowLevel* interactorWindowLevel)
{    
	_manualinteractorwindowlevel = interactorWindowLevel;
	AddInteractorStyleMaracas(_manualinteractorwindowlevel);
}

//---------------------------------------------------------------------------
void  vtkInteractorStyleBaseView2D::OnRightButtonDown()  // virtual
{    
	vtkInteractorStyleBaseView::OnRightButtonDown();

	if ((GetInteractor()->GetControlKey()==1) && (GetInteractor()->GetShiftKey()==0) ){
		this->vtkInteractorStyleImage::OnRightButtonDown();
	}

}

//---------------------------------------------------------------------------
void  vtkInteractorStyleBaseView2D::OnRightButtonUp()  // virtual
{
	vtkInteractorStyleBaseView::OnRightButtonUp();
	this->vtkInteractorStyleImage::OnRightButtonUp();
}
//---------------------------------------------------------------------------
void  vtkInteractorStyleBaseView2D::OnMouseMove () // virtual
{
	vtkInteractorStyleBaseView::OnMouseMove();
	this->vtkInteractorStyleImage::OnMouseMove();
}
//---------------------------------------------------------------------------
void  vtkInteractorStyleBaseView2D::OnLeftButtonDown() // virtual
{
	vtkInteractorStyleBaseView::OnLeftButtonDown();

	if ((GetInteractor()->GetControlKey()==0) && (GetInteractor()->GetShiftKey()==1) )
	{
		this->vtkInteractorStyleImage::OnLeftButtonDown();
	}
}
//---------------------------------------------------------------------------
void  vtkInteractorStyleBaseView2D::OnLeftButtonUp () // virtual
{
	vtkInteractorStyleBaseView::OnLeftButtonUp();

	this->vtkInteractorStyleImage::OnLeftButtonUp();
}
//---------------------------------------------------------------------------
void  vtkInteractorStyleBaseView2D::OnMiddleButtonDown () // virtual
{
	vtkInteractorStyleBaseView::OnMiddleButtonDown();

	if ((GetInteractor()->GetControlKey()==1) || (GetInteractor()->GetShiftKey()==1) )
	{
		this->vtkInteractorStyleImage::OnLeftButtonDown();
	}
}
//---------------------------------------------------------------------------
void vtkInteractorStyleBaseView2D::OnMiddleButtonUp () // virtual
{
	vtkInteractorStyleBaseView::OnMiddleButtonUp();

	if ((GetInteractor()->GetControlKey()==1) || (GetInteractor()->GetShiftKey()==1) )
	{
		this->vtkInteractorStyleImage::OnLeftButtonUp();
	}
}

