/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: wxMaracasMultipleVolumeRendererView.h,v $
  Language:  C++
  Date:      $Date: 2010/01/13 13:31:10 $
  Version:   $Revision: 1.6 $

  Copyright: (c) 2002, 2003
  License:

     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#ifndef __wxMaracasMultipleVolumeRendererViewPanelH__
#define __wxMaracasMultipleVolumeRendererViewPanelH__

#include <vector>
#include <wx/wx.h>
#include "wx/aui/aui.h"
#include <iostream>
#include "marTypes.h"
#include "vtkProp3D.h"

#include "wxMaracasMultipleVolumeRendererManager.h"
#include "wxMaracasMultipleVolumeRendererPanel.h"



class  creaMaracasVisu_EXPORT  wxMaracasMultipleVolumeRendererView : public wxPanel
{

public:
	wxMaracasMultipleVolumeRendererView( wxWindow* parent, std::string path);
    ~wxMaracasMultipleVolumeRendererView( );

	static wxMaracasMultipleVolumeRendererView* getInstance(wxWindow* parent,std::string path="");

	static wxMaracasMultipleVolumeRendererView* getInstance();

	void setRenderer(vtkRenderer*  renderer);
	
	void addVolume(vtkImageData* img, std::string dataname="");		

	void loadVolume(wxString filename, wxString dataname);

	void onLoadImageFile();

	void addVolumeRendererPanel(wxMaracasMultipleVolumeRendererPanel* irmview, std::string dataname="");

	std::string getPath();

	void deleteVolume(int volid);

	void addRemoveActor(int id, bool remove);	

	void SetValuesColorPointsFunction(int volid, std::vector<double> greylevelcolors,std::vector<double> red,std::vector<double> green,std::vector<double> blue);
	void SetValuesPointsFunction(int volid, std::vector<double> greylevel, std::vector<double> values);

	void addVolumeViewPanel(wxMaracasMultipleVolumeRendererPanel* irmview, std::string dataname);

	vtkPiecewiseFunction* GetTransferFunction(int volumeid);
	vtkColorTransferFunction* GetColorFunction(int volumeid);

	std::vector<vtkImageData*> GetOutputImages();

	void changeCompositeMIPFunction(int id, int function);

	wxMaracasMultipleVolumeRendererManager* getVolumeRenderManager();

private:
	static wxMaracasMultipleVolumeRendererView* instance;

	wxMaracasMultipleVolumeRendererManager* volmanager;
	wxAuiManager* wxauimanager;
	wxToolBar* _toolb;
	
	std::string _path;
    std::vector<vtkImageData*> imgVect;
};

class ToolBarEventHandlerMultipleVolumeRenderer : public wxEvtHandler{

	public:
		ToolBarEventHandlerMultipleVolumeRenderer();
		~ToolBarEventHandlerMultipleVolumeRenderer();

		void onLoadImageFile(wxCommandEvent& event);

	private:

		DECLARE_EVENT_TABLE()
	};

class ToolBarMultipleVolumeRenderer : public wxToolBar{

	
public:
	ToolBarMultipleVolumeRenderer(wxWindow * parent,std::string iconsdir);
	~ToolBarMultipleVolumeRenderer(void);


private:

	ToolBarEventHandlerMultipleVolumeRenderer* _evthand;

};

#endif

