#ifndef WXVTKMPR3DVIEWCNTRLPANEL_H_
#define WXVTKMPR3DVIEWCNTRLPANEL_H_

#include "wxVtkMPR3DView.h"

#include "wx/wx.h"

class wxVtkMPR3DView;

class wxVtkMPR3DViewCntrlPanel: public wxPanel
{
public:
	wxVtkMPR3DViewCntrlPanel(wxWindow *parent, wxVtkMPR3DView *wxvtkmpr3Dview, bool align);
	~wxVtkMPR3DViewCntrlPanel();
	void		OnVisibleAxisX(wxCommandEvent& event);
	void		OnVisibleAxisY(wxCommandEvent& event);
	void		OnVisibleAxisZ(wxCommandEvent& event);
	void		OnPositionX(wxScrollEvent& event);
	void		OnPositionY(wxScrollEvent& event);
	void		OnPositionZ(wxScrollEvent& event);
	void		OnVisibleAxisXYZ(wxCommandEvent& event);
	void		OnVisiblePlane(wxCommandEvent& event);
	void		OnEditColorTable(wxCommandEvent& event);
	
	void OnVisibleFreePlaneX(wxCommandEvent& event);
	void OnVisibleFreePlaneY(wxCommandEvent& event);
	void OnVisibleFreePlaneZ(wxCommandEvent& event);
	void OnVisibleFreePlaneInteraction(wxCommandEvent& event);
	
	
	
	virtual void Refresh();
	void		UpdateControlPanel();

	bool		GetVisibleX();
	bool		GetVisibleY();
	bool		GetVisibleZ();
	bool		GetVisibleXYZ();
	bool		GetVisiblePlane();
	void		SetVisibleX(bool value);
	void		SetVisibleY(bool value);
	void		SetVisibleZ(bool value);
	void		SetVisibleXYZ(bool value);
	void		SetVisiblePlane(bool value);

private:
	wxVtkMPR3DView	*_wxvtkmpr3Dview;

	wxSlider		*_opacity;
	wxSlider		*_isoValue;
	wxSlider		*_isoValueSpin;
	wxStaticText	*_isoValueText;
	wxRadioButton	*_surfA;
	wxRadioButton	*_surfB;
	wxRadioButton	*_surfC;
	wxRadioButton	*_surfD;
	wxCheckBox		*_visible;
	wxButton		*_color;
	wxSlider		*_positionX;
	wxSlider		*_positionY;	
	wxSlider		*_positionZ;
	
	//CPR: Added 30 nov 2009
	wxCheckBox		*ckBoxX;
	wxCheckBox		*ckBoxY;
	wxCheckBox		*ckBoxZ;

	wxCheckBox		*_ckBoxXYZ;
	wxCheckBox		*_ckBoxPlane;
	
	wxCheckBox      *_ckFreePlaneX;
	wxCheckBox      *_ckFreePlaneY;
	wxCheckBox      *_ckFreePlaneZ;
	wxCheckBox      *_ckFreePlaneInteraction;


protected:

};

#endif /*WXVTKMPR3DVIEWCNTRLPANEL_H_*/
