#ifndef WXWIDGETMESURE2D_H_
#define WXWIDGETMESURE2D_H_

#include <wx/splitter.h>
#include <wx/checkbox.h>
#include "manualContourControler.h"
#include "manualContourModel.h"
#include "manualViewContour.h"

#include "wxVtk2DBaseView.h"

class wxWidgetMesure2D : public wxSplitterWindow
{
public: 
	wxWidgetMesure2D( wxWindow *parent );
	~wxWidgetMesure2D();

	void OnActiveMessureTool(wxCommandEvent& event);
	void OnVisibleMessureTool(wxCommandEvent& event);
	void OnCloseContour(wxCommandEvent& event);
	void OnVisibleInformation(wxCommandEvent& event);

	void SetMesureScale(double mesureScale);

	manualContourModel*	GetManualContourModel();
	virtual void ConfigureA(wxVtk2DBaseView *wxvtk2Dbaseview);

protected:
	wxVtk2DBaseView			*_wxvtk2Dbaseview;
	virtual wxWindow		*CreateWin1a(wxWindow *parent);
private:
	wxCheckBox				*_cb_messuretool; 
	wxCheckBox				*_cb_mt_visible; 
	wxCheckBox				*_cb_closeContour; 
	wxCheckBox				*_cb_visibleText; 

	manualContourControler	*_manContourControl_1;
	manualContourModel		*_mContourModel_1;
	manualViewContour		*_mViewContour_1;

	void	ActiveMessureTool(bool ok);

//	DECLARE_EVENT_TABLE();
};


#endif /*WXWIDGETMESURE2D_H_*/
