/*=========================================================================

  */

#ifndef __carotidaBifurcacion_h
#define __carotidaBifurcacion_h

#include "vtkPolyDataSource.h"
#include "vtkImageThreshold.h"
#include "vtkImageCast.h"
#include "vtkImageSeedConnectivity.h"
#include "vtkImageData.h"
#include "vtkMarchingCubes.h"
#include "vtkDoubleArray.h"
#include "vtkPointData.h"
#include "vtkExtractVOI.h"
#include "vtkPoints.h"
#include "vtkCellArray.h"


class vtkPolyData;

class  carotidaBifurcacion : public vtkPolyDataSource
{
public:
	static carotidaBifurcacion *New();
	void PrintSelf(ostream& os, vtkIndent indent);

	virtual void SetInput(vtkPolyData *input);
	vtkPolyData *GetInput();

	virtual void SetInput2(vtkImageData *input);
	vtkImageData *GetInput2();

	void SetMaxPropRadio(double value);
	double GetMaxPropRadio();

	void SetHumbral(double value);
	double GetHumbral();

	void SetMaxPropMasa(double value);
	double GetMaxPropMasa();

	void SetMinPropMasa(double value);
	double GetMinPropMasa();
  
  
protected:  
	carotidaBifurcacion();
	
	~carotidaBifurcacion() {};

	void Execute();
 
  

private:
	carotidaBifurcacion(const carotidaBifurcacion&);  // Not implemented.

	void operator=(const carotidaBifurcacion&);  // Not implemented.
  
	void searc(int i, int j, int k );

	void find_components( );

	unsigned short maximo();

	void blanquear();

	double angulo(double i1, double j1, double k1, double i2, double j2, double k2 );

	void direcciones(vtkPolyData *points, int iter, double radio, double puntocortea[3], double puntocortes[3] );

	void corte(double punto1[3], double punto2[3], double punto3[3], double centro[3],  double radio );

	void avanzar(vtkIdType iter);

	int proporcion(vtkImageData *data );

	void redondear(vtkImageData *data );

	void limpiar(vtkPoints *profile, vtkPoints *profile2, vtkPoints *profile3, vtkPoints *profile4 );

	int igual(double puntoactual[3], double puntoactualdis[3], double puntoantguar[3], double puntoantguardis[3] );



	vtkImageData *dataprov;
	unsigned char label;
	unsigned long vector[50][4] ;
	vtkExtractVOI *extrac;
	vtkImageThreshold *thresh;
	vtkImageCast *cast;
	vtkImageSeedConnectivity *connect;
	vtkIdType iter;

	vtkPoints *points;

	vtkCellArray *lineas; 

	
	vtkDoubleArray *salidas;

	double humbral;
	double maxpropradio;
	double maxpropmasa;
	double minpropmasa;


	vtkPoints *points2;

	vtkPoints *points3;
	vtkPoints *points4;

 

	int buenos2;
	
};

#endif


