/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marPoint.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 13:55:08 $
  Version:   $Revision: 1.1 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#ifndef __MAR__KERNEL__POINT__HXX__
#define __MAR__KERNEL__POINT__HXX__


#include "marTypes.h"

class MAR_KERNEL_EXPORT marPoint  
{
public:
	marPoint(double x, double y);
	~marPoint();
	double getX();
	double getY();
	void setPoint(double x, double y);
	void setGradient(double g);
	double getGradient();
	int getDirection();
	bool getInside();
	void setDirection(int direction);
	void setInside (bool ins);
	void setIntensity(double intensity);
	double getIntensity();
	void setType(int type);
	int getType();

private:
	double x;
	double y;
	double gradient;
	int dir;		//Ray's direction
	bool inside;	//Point's location
	double intensity;
	int type;

};

#endif // __MAR__KERNEL__POINT__HXX__

